# $Id: bt.init.mk,v 1.35 2003/09/03 13:41:11 jmmv Exp $

.if !defined(__BT_INIT_MK)
__BT_INIT_MK= 1

# Include system-wide configuration file, if found.
.-include "${BTOWN_DIR_CONF}/bt_make.conf"

# List of files to clean.
BT_FILES_CLEAN?=
BT_FILES_CLEANDIR?=

# Try to guess top directory, if not specified already. We MUST know
# it to work properly!
.if !defined(BT_TOPDIR)
BT_TOPDIR!=	cd ${.CURDIR}; while :; do \
		here=`pwd`; \
		[ -f "Generic.bt" -o -f "Defs.bt" ] && \
		{ echo $$here; break; }; \
		case $$here in /) echo ""; break;; esac; \
		cd ..; done
.endif

# Check for REQUIRED bt_config.mk presence.
.if exists(${BT_TOPDIR}/bt_config.mk)
.  if make(tologic)
_VARS!=	grep ' = ' ${BT_TOPDIR}/bt_config.mk | cut -d '=' -f 1
_BT_TOPDIR:= ${BT_TOPDIR}
.    for v in ${_VARS}
.      if !defined($v)
$v=
.      endif
.    endfor
.    undef v
BT_TOPDIR:= ${_BT_TOPDIR}
.    undef _BT_TOPDIR
.  else
.    include "${BT_TOPDIR}/bt_config.mk"
.  endif
.else
.    abort bt_config.mk not found, use "buildtool config" first.
.endif

# Include common Makefile, if found.
.-include "${.CURDIR}/../Makefile.inc"

BT_BUILDLOG=		${.CURDIR}/.bt_wrap.log

.if defined(BT_FEATURE_DEVELOPER) && !empty(BT_FEATURE_DEVELOPER:M[Yy][Ee][Ss])
BT_WRAP=		env -i ${BT_WRAP_ENV} ${BTOWN_DIR_MODS}/bt_wrap \
			-l ${BT_BUILDLOG}
.else
BT_WRAP=		env -i ${BT_WRAP_ENV} ${BTOWN_DIR_MODS}/bt_wrap
.endif

BT_WRAP_ENV+=		__BUILDTOOL="yes"
BT_WRAP_ENV+=		BT_TOPDIR="${BT_TOPDIR}"
BT_WRAP_ENV+=		BT_WRAP_MKSTATIC="${BT_LIB_MKSTATIC}"
BT_WRAP_ENV+=		BT_WRAP_MKPIC="${BT_LIB_MKPIC}"
BT_WRAP_ENV+=		PATH="${BT_PATH}"
BT_FILES_CLEAN+=	${BT_BUILDLOG} bt_run

BT_INSTALL_BIN=		${BT_WRAP} install -t bin
BT_INSTALL_DIR=		${BT_WRAP} install -t dir
BT_INSTALL_DATA=	${BT_WRAP} install -t data
BT_INSTALL_LIB=		${BT_WRAP} install -t lib
BT_INSTALL_SYMLINK=	${BT_WRAP} ln -s

# --------------------------------------------------------------------
# Targets
# --------------------------------------------------------------------

# Common targets.
BT_TARGETS+=	all clean cleandir deinstall depend install obj tologic
.PHONY:		all clean cleandir deinstall depend install obj tologic

# Internal targets (those that the user should not call directly).
.PHONY:		real-deinstall pre-deinstall post-deinstall \
		real-depend    pre-depend    post-depend \
		real-install   pre-install   post-install \
		real-all       pre-all       post-all \
		real-tologic   pre-tologic   post-tologic \
		subdir-all subdir-deinstall \
		subdir-depend subdir-install

# Install-related targets
.if !target(install)
install:		.NOTMAIN pre-install subdir-install \
			         real-install post-install
pre-install:		.NOTMAIN
subdir-install:		.NOTMAIN pre-install
real-install:		.NOTMAIN pre-install
post-install:		.NOTMAIN subdir-install real-install
.endif

# Deinstall-related targets
.if !target(deinstall)
deinstall:		.NOTMAIN pre-deinstall subdir-deinstall \
			         real-deinstall post-deinstall
pre-deinstall:		.NOTMAIN
subdir-deinstall:	.NOTMAIN pre-deinstall
real-deinstall:		.NOTMAIN pre-deinstall
post-deinstall:		.NOTMAIN subdir-deinstall real-deinstall
.endif

# Other important targets
all:		.NOTMAIN pre-all real-all post-all subdir-all
subdir-all:	.NOTMAIN
pre-all:	.NOTMAIN
real-all:	.NOTMAIN
post-all:	.NOTMAIN
depend:		.NOTMAIN real-depend subdir-depend
subdir-depend:	.NOTMAIN
real-depend:	.NOTMAIN
distclean:	.NOTMAIN cleandir
cleandir:	.NOTMAIN clean
clean:		.NOTMAIN
tologic:	.NOTMAIN pre-tologic real-tologic post-tologic

# Force our main target to be "all".
.MAIN:		all

real-tologic:

pre-tologic:
.if make(tologic)
.if exists(Logic.bt)
.       abort Logic.bt already exists in the current directory.
.endif
.endif
.if ${BT_TOPDIR} != ${PWD}
	@echo "#" > Logic.bt
	@echo "# Logic.bt file." >> Logic.bt
	@echo "#" >> Logic.bt
	@echo >> Logic.bt
.endif

post-tologic:
.if ${BT_TOPDIR} != ${PWD}
	@echo "Logic.bt created successfully."
.else
	@echo "Generic.bt updated successfully (logic function added)."
.endif

.endif		# __BT_INIT_MK
